<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>formatters/htmlStandardFormatter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/formatters/htmlstandardformatter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>formatters/htmlStandardFormatter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>    
<a name="line3"></a>    require_once(dirname(__file__).DIRECTORY_SEPARATOR.'textFormatter.php');
<a name="line4"></a>    
<a name="line5"></a>    /**
<a name="line6"></a>     * The standard formatter. Basic implementation, just deals with unordered lists for now.
<a name="line7"></a>     *
<a name="line8"></a>     * @package PHPDoctor\Formatters
<a name="line9"></a>     */
<a name="line10"></a>    class htmlStandardFormatter extends TextFormatter
<a name="line11"></a>    {
<a name="line12"></a>        
<a name="line13"></a>        function toFormattedText($text)
<a name="line14"></a>        {
<a name="line15"></a>            $text = $this->_addListMarkupUL($text);
<a name="line16"></a>            $text = '<p>'.str_replace("\n\n", '</p><p>', $this->toPlainText($text)).'</p>';
<a name="line17"></a>            $text = str_replace('<ul>', "</p>\n<ul>", $text);
<a name="line18"></a>            $text = str_replace('</ul>', "</ul>\n<p>", $text);
<a name="line19"></a>            $text = $this->_removeWhitespace($text);
<a name="line20"></a>            return $text;
<a name="line21"></a>        }
<a name="line22"></a>        
<a name="line23"></a>        /**
<a name="line24"></a>         * Detects unordered lists and adds the necessary markup.
<a name="line25"></a>         * 
<a name="line26"></a>         * @param  string  $txt 			the text to parse and modify
<a name="line27"></a>         * @return string    
<a name="line28"></a>         */
<a name="line29"></a>        function _addListMarkupUL($txt)
<a name="line30"></a>        {
<a name="line31"></a>            // Create unordered lists. -, +, # and o are recogized as bullet points
<a name="line32"></a>            
<a name="line33"></a>            // $li_rx: regex capturing a list entry, including those extending over multiple lines and
<a name="line34"></a>            //         those padded with empty lines
<a name="line35"></a>            // $ul_rx: regex capturing an unordered list - at least two list entries required
<a name="line36"></a>            $li_rx = '^([ \t]+([\-+#o])[ \t]+)(\S.*(?:\n [ \t]+(?!\2)(?![ \t]).*|\n[ \t]*)*\n)';
<a name="line37"></a>            $ul_rx = "(?:$li_rx){2,}";
<a name="line38"></a>            
<a name="line39"></a>            $txt = preg_replace("/$ul_rx/m", "\n\n<ul>\n$0\n</ul>\n\n", $txt);
<a name="line40"></a>            
<a name="line41"></a>            if (preg_match_all("%<ul>.*?</ul>%s", $txt, $outerLists)) {
<a name="line42"></a>                $lists = preg_replace("/$li_rx/m", "<li>$3</li>", $outerLists[0]);
<a name="line43"></a>                $txt = str_replace($outerLists[0], $lists, $txt);
<a name="line44"></a>                
<a name="line45"></a>                // Cleanup: Making sure that the lists won't appear inside a <p> (by removing double newlines around ul tags)
<a name="line46"></a>                // and won't have empty paragraphs in between list items (by removing double newlines between different li tags).
<a name="line47"></a>                $txt = preg_replace('%\s*<ul>\s*(<li>.+?</li>)\s*</ul>\s*%s', "<ul>\n$1\n</ul>", $txt);
<a name="line48"></a>                $txt = preg_replace('%\s*</li>\s*%', "</li>\n", $txt);
<a name="line49"></a>                
<a name="line50"></a>                // Inside <li>s which contain multiple paragraphs, use <p>s with a css hook.
<a name="line51"></a>                preg_match_all("%<li>.*?</li>%s", $txt, $items);
<a name="line52"></a>                $adjustedItems = preg_replace("%[ \t]*\n[ \t]*\n[ \t]*%", '</p><p class="list">', $items[0]);
<a name="line53"></a>                $adjustedItems = preg_replace('%^<li>(.*?</p><p class="list">.*?)</li>$%s', "<li><p class=\"list\">$1</p></li>", $adjustedItems);
<a name="line54"></a>                $txt = str_replace($items[0], $adjustedItems, $txt);
<a name="line55"></a>                
<a name="line56"></a>            } 
<a name="line57"></a>            
<a name="line58"></a>            return $txt;
<a name="line59"></a>        }
<a name="line60"></a>        
<a name="line61"></a>    }
<a name="line62"></a>    
<a name="line63"></a>?></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/formatters/htmlstandardformatter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>